local L = LibStub("AceLocale-3.0"):GetLocale("BossTactics")
local BabbleClass = LibStub("LibBabble-Class-3.0"):GetLookupTable();

---------------------------------------------------------
--- opens dialog if data musst be updated panel
-- optional: message
---------------------------------------------------------

function BossTactics:ShowUpdateInfoFrame(message)
    if(self.UpdateFrame == nil)then
        self.UpdateFrame = CreateFrame("Frame","BT_UpdateFrame",UIParent)
        self.UpdateFrame:ClearAllPoints()
        self.UpdateFrame:SetPoint("CENTER",UIParent)
        self.UpdateFrame:SetHeight(150)
        self.UpdateFrame:SetWidth(350)
        self.UpdateFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.UpdateFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.UpdateFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.UpdateFrame.YesBtn = CreateFrame("Button","BT_updateframe_ok",self.UpdateFrame,"UIPanelButtonTemplate")
        self.UpdateFrame.YesBtn:SetWidth(60)
        self.UpdateFrame.YesBtn:SetHeight(20)
        self.UpdateFrame.YesBtn:SetText(L["Yes"])
        self.UpdateFrame.YesBtn:SetPoint("BOTTOMLEFT",self.UpdateFrame,"BOTTOMLEFT",15,15)
        self.UpdateFrame.YesBtn:SetScript("OnClick",function()
            local currModule = LibStub("AceAddon-3.0"):GetAddon( self.currInstanceId )
            currModule:ResetData()
            self:RestoreDefaults()
        this:GetParent():Hide() end)
        self.UpdateFrame.YesBtn:SetFrameLevel(self.UpdateFrame:GetFrameLevel()+1)

        self.UpdateFrame.NoBtn = CreateFrame("Button","BT_updateframe_c",self.UpdateFrame,"UIPanelButtonTemplate")
        self.UpdateFrame.NoBtn:SetWidth(100)
        self.UpdateFrame.NoBtn:SetHeight(20)
        self.UpdateFrame.NoBtn:SetText(L["No"])
        self.UpdateFrame.NoBtn:SetPoint("BOTTOMLEFT",self.UpdateFrame,"BOTTOMLEFT",120,15)
        self.UpdateFrame.NoBtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.UpdateFrame.NoBtn:SetFrameLevel(self.UpdateFrame:GetFrameLevel()+1)

        self.UpdateFrame.infotext = self.UpdateFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.UpdateFrame.infotext:SetTextColor(1,1,1)
        self.UpdateFrame.infotext:SetWidth(330)
        self.UpdateFrame.infotext:SetPoint("TOP",self.UpdateFrame,"TOP",10,-25)
        self.UpdateFrame.infotext:SetJustifyH("LEFT")

        self.UpdateFrame.closebtn=CreateFrame("Button","BT_uinfoclose",self.UpdateFrame)
        self.UpdateFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.UpdateFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.UpdateFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.UpdateFrame.closebtn:SetWidth(20)
        self.UpdateFrame.closebtn:SetHeight(20)
        self.UpdateFrame.closebtn:SetPoint("TOPRIGHT",self.UpdateFrame,"TOPRIGHT",-5,-5)
        self.UpdateFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.UpdateFrame.closebtn:SetFrameLevel(self.UpdateFrame:GetFrameLevel()+1)
    end
    if(message)then
        self.UpdateFrame.infotext:SetText(message)
    else
        self.UpdateFrame.infotext:SetText(L["update info text"])
    end
    self.UpdateFrame:Show()
    self.UpdateFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)

end;

---------------------------------------------------------
--- opens dialog with yes no choice
---------------------------------------------------------

function BossTactics:ShowQuestionFrame(message, yesFunc, noFunc, arg1Yes, arg2Yes, arg1No, arg2No)
    if(self.QuestionFrame == nil)then
        self.QuestionFrame = CreateFrame("Frame","BT_QuestionFrame",UIParent)
        self.QuestionFrame:ClearAllPoints()
        self.QuestionFrame:SetPoint("CENTER",UIParent)
        self.QuestionFrame:SetHeight(200)
        self.QuestionFrame:SetWidth(350)
        self.QuestionFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.QuestionFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.QuestionFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.QuestionFrame.YesBtn = CreateFrame("Button","BT_QuestionFrame_ok",self.QuestionFrame,"UIPanelButtonTemplate")
        self.QuestionFrame.YesBtn:SetWidth(60)
        self.QuestionFrame.YesBtn:SetHeight(20)
        self.QuestionFrame.YesBtn:SetText(L["Yes"])
        self.QuestionFrame.YesBtn:SetPoint("BOTTOMLEFT",self.QuestionFrame,"BOTTOMLEFT",15,15)
        self.QuestionFrame.YesBtn:SetScript("OnClick",function()
        	this:GetParent():Hide()
            if(self.QuestionFrame.YesFunc)then
                self.QuestionFrame.YesFunc(self.QuestionFrame.yesArg1,self.QuestionFrame.yesArg2)
            end
           end)
        self.QuestionFrame.YesBtn:SetFrameLevel(self.QuestionFrame:GetFrameLevel()+1)

        self.QuestionFrame.NoBtn = CreateFrame("Button","BT_QuestionFrame_c",self.QuestionFrame,"UIPanelButtonTemplate")
        self.QuestionFrame.NoBtn:SetWidth(60)
        self.QuestionFrame.NoBtn:SetHeight(20)
        self.QuestionFrame.NoBtn:SetText(L["No"])
        self.QuestionFrame.NoBtn:SetPoint("BOTTOMLEFT",self.QuestionFrame,"BOTTOMLEFT",120,15)
        self.QuestionFrame.NoBtn:SetScript("OnClick",function()
        			this:GetParent():Hide()
                    if(self.QuestionFrame.NoFunc)then
                        self.QuestionFrame.NoFunc(self.QuestionFrame.noArg1,self.QuestionFrame.noArg2)
                    end
             end)
        self.QuestionFrame.NoBtn:SetFrameLevel(self.QuestionFrame:GetFrameLevel()+1)

        self.QuestionFrame.infotext = self.QuestionFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.QuestionFrame.infotext:SetTextColor(1,1,1)
        self.QuestionFrame.infotext:SetWidth(270)
        self.QuestionFrame.infotext:SetPoint("TOP",self.QuestionFrame,"TOP",10,-25)
        self.QuestionFrame.infotext:SetJustifyH("CENTER")
    end
    self.QuestionFrame.YesFunc = yesFunc
    self.QuestionFrame.NoFunc = noFunc
    self.QuestionFrame.yesArg1 = arg1Yes
    self.QuestionFrame.yesArg2 = arg2Yes
    self.QuestionFrame.noArg1 = arg1No
    self.QuestionFrame.noArg2 = arg2No
    self.QuestionFrame:Show()
    self.QuestionFrame.infotext:SetText(message)
    if(self.MainWindow)then
        self.QuestionFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
    end

end;

---------------------------------------------------------
--- update information frame
---------------------------------------------------------

function BossTactics:ShowUpdateMessageFrame(message, allFunc, okFunc, arg1All, arg2All, arg1Ok, arg2Ok)
    if(self.UpdateMessageFrame == nil)then
        self.UpdateMessageFrame = CreateFrame("Frame","BT_UpdateMessageFrame",UIParent)
        self.UpdateMessageFrame:ClearAllPoints()
        self.UpdateMessageFrame:SetPoint("CENTER",UIParent)
        self.UpdateMessageFrame:SetHeight(200)
        self.UpdateMessageFrame:SetWidth(350)
        self.UpdateMessageFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.UpdateMessageFrame:SetBackdropColor(1/255, 1/255, 1/255)

        self.UpdateMessageFrame.okBtn = CreateFrame("Button","BT_UpdateMessageFrame_ok",self.UpdateMessageFrame,"UIPanelButtonTemplate")
        self.UpdateMessageFrame.okBtn:SetWidth(60)
        self.UpdateMessageFrame.okBtn:SetHeight(20)
        self.UpdateMessageFrame.okBtn:SetText(L["Ok"])
        self.UpdateMessageFrame.okBtn:SetPoint("BOTTOMLEFT",self.UpdateMessageFrame,"BOTTOMLEFT",15,15)
        self.UpdateMessageFrame.okBtn:SetScript("OnClick",function()
        	if(self.UpdateMessageFrame.OkFunc)then
            	self.UpdateMessageFrame.OkFunc(self.UpdateMessageFrame.okArg1,self.UpdateMessageFrame.okArg2)
            end
            this:GetParent():Hide()
           end)
        self.UpdateMessageFrame.okBtn:SetFrameLevel(self.UpdateMessageFrame:GetFrameLevel()+1)

        self.UpdateMessageFrame.AllBtn = CreateFrame("Button","BT_UpdateMessageFrame_c",self.UpdateMessageFrame,"UIPanelButtonTemplate")
        self.UpdateMessageFrame.AllBtn:SetWidth(60)
        self.UpdateMessageFrame.AllBtn:SetHeight(20)
        self.UpdateMessageFrame.AllBtn:SetText(L["All"])
        self.UpdateMessageFrame.AllBtn:SetPoint("BOTTOMLEFT",self.UpdateMessageFrame,"BOTTOMLEFT",120,15)
        self.UpdateMessageFrame.AllBtn:SetScript("OnClick",function()
                    if(self.UpdateMessageFrame.AllFunc)then
            	        self.UpdateMessageFrame.AllFunc(self.UpdateMessageFrame.allArg1,self.UpdateMessageFrame.allArg2)
                    end
                    this:GetParent():Hide()
             end)
        self.UpdateMessageFrame.AllBtn:SetFrameLevel(self.UpdateMessageFrame:GetFrameLevel()+1)

        self.UpdateMessageFrame.infotext = self.UpdateMessageFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.UpdateMessageFrame.infotext:SetTextColor(1,1,1)
        self.UpdateMessageFrame.infotext:SetWidth(270)
        self.UpdateMessageFrame.infotext:SetText(message)
        self.UpdateMessageFrame.infotext:SetPoint("TOP",self.UpdateMessageFrame,"TOP",10,-25)
        self.UpdateMessageFrame.infotext:SetJustifyH("CENTER")

    end
    self.UpdateMessageFrame:Show()
    self.UpdateMessageFrame.AllFunc = allFunc
    self.UpdateMessageFrame.allArg1 = arg1All
    self.UpdateMessageFrame.allArg2 = arg2All
    self.UpdateMessageFrame.OkFunc = okFunc
    self.UpdateMessageFrame.okArg1 = arg1Ok
    self.UpdateMessageFrame.okArg2 = arg2Ok
    if(self.MainWindow)then
        self.UpdateMessageFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
    end

end;

---------------------------------------------------------
--- opens dialog if a user in group > self.currInstanceMemberMax
---------------------------------------------------------

function BossTactics:ShowTacticQuestionFrame(target)
	if(self.isNotWatchingAsked) then return end
	self.isNotWatching = true
    if(self.TacticQuestionFrame == nil)then
        self.TacticQuestionFrame = CreateFrame("Frame","BT_TacticQuestionFrame",UIParent)
        self.TacticQuestionFrame:ClearAllPoints()
        self.TacticQuestionFrame:SetPoint("CENTER",UIParent)
        self.TacticQuestionFrame:SetHeight(120)
        self.TacticQuestionFrame:SetWidth(350)
        self.TacticQuestionFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.TacticQuestionFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.TacticQuestionFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.TacticQuestionFrame.YesBtn = CreateFrame("Button","BT_TacticQuestionFrame_ok",self.TacticQuestionFrame,"UIPanelButtonTemplate")
        self.TacticQuestionFrame.YesBtn:SetWidth(60)
        self.TacticQuestionFrame.YesBtn:SetHeight(20)
        self.TacticQuestionFrame.YesBtn:SetText(L["Yes"])
        self.TacticQuestionFrame.YesBtn:SetPoint("BOTTOMLEFT",self.TacticQuestionFrame,"BOTTOMLEFT",15,15)
        self.TacticQuestionFrame.YesBtn:SetScript("OnClick",function()
            self.isNotWatching = false;
            self.isNotWatchingAsked = false
            self:StartUserSession(target, true)
            self:BT_SendDataMessage("{SYNCREQ}")
            this:GetParent():Hide()
        this:GetParent():Hide() end)
        self.TacticQuestionFrame.YesBtn:SetFrameLevel(self.TacticQuestionFrame:GetFrameLevel()+1)

        self.TacticQuestionFrame.NoBtn = CreateFrame("Button","BT_TacticQuestionFrame_c",self.TacticQuestionFrame,"UIPanelButtonTemplate")
        self.TacticQuestionFrame.NoBtn:SetWidth(60)
        self.TacticQuestionFrame.NoBtn:SetHeight(20)
        self.TacticQuestionFrame.NoBtn:SetText(L["No"])
        self.TacticQuestionFrame.NoBtn:SetPoint("BOTTOMLEFT",self.TacticQuestionFrame,"BOTTOMLEFT",120,15)
        self.TacticQuestionFrame.NoBtn:SetScript("OnClick",function()
                    self.isNotWatching = true
                    self.isNotWatchingAsked = true
                    this:GetParent():Hide()
             end)
        self.TacticQuestionFrame.NoBtn:SetFrameLevel(self.TacticQuestionFrame:GetFrameLevel()+1)

        self.TacticQuestionFrame.infotext = self.TacticQuestionFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.TacticQuestionFrame.infotext:SetTextColor(1,1,1)
        self.TacticQuestionFrame.infotext:SetWidth(270)
        self.TacticQuestionFrame.infotext:SetText(L["tactic question text"])
        self.TacticQuestionFrame.infotext:SetPoint("TOP",self.TacticQuestionFrame,"TOP",10,-25)
        self.TacticQuestionFrame.infotext:SetJustifyH("CENTER")

        self.TacticQuestionFrame.closebtn=CreateFrame("Button","BT_uinfoclose",self.TacticQuestionFrame)
        self.TacticQuestionFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.TacticQuestionFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.TacticQuestionFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.TacticQuestionFrame.closebtn:SetWidth(20)
        self.TacticQuestionFrame.closebtn:SetHeight(20)
        self.TacticQuestionFrame.closebtn:SetPoint("TOPRIGHT",self.TacticQuestionFrame,"TOPRIGHT",-5,-5)
        self.TacticQuestionFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.TacticQuestionFrame.closebtn:SetFrameLevel(self.TacticQuestionFrame:GetFrameLevel()+1)
    end
    self.TacticQuestionFrame:Show()
    if(self.MainWindow)then
        self.TacticQuestionFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
    end

end;

---------------------------------------------------------
--- opens Info panel
---------------------------------------------------------

function BossTactics:ShowInfoFrame()
    if(self.InfoFrame == nil)then
        self.InfoFrame = CreateFrame("Frame","BT_infoframe",UIParent)
        self.InfoFrame:ClearAllPoints()
        self.InfoFrame:SetPoint("CENTER",UIParent)
        self.InfoFrame:SetHeight(270)
        self.InfoFrame:SetWidth(350)
        self.InfoFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.InfoFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.InfoFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.InfoFrame.OkBtn = CreateFrame("Button","BT_infoframe_ok",self.InfoFrame,"UIPanelButtonTemplate")
        self.InfoFrame.OkBtn:SetWidth(100)
        self.InfoFrame.OkBtn:SetHeight(20)
        self.InfoFrame.OkBtn:SetText(L["Ok"])
        self.InfoFrame.OkBtn:SetPoint("BOTTOM",self.InfoFrame,"BOTTOM",0,15)
        self.InfoFrame.OkBtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.InfoFrame.OkBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        self.InfoFrame.title = self.InfoFrame:CreateFontString(nil,"OVERLAY","MailTextFontNormal")
        self.InfoFrame.title:SetTextColor(1,1,1)
        self.InfoFrame.title:SetText(string.format(L["title info"],self.version))
        self.InfoFrame.title:SetPoint("TOP",self.InfoFrame,"TOP",0,-15)

        self.InfoFrame.infotext = self.InfoFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.InfoFrame.infotext:SetTextColor(1,1,1)
        self.InfoFrame.infotext:SetWidth(330)
        self.InfoFrame.infotext:SetHeight(200)
        self.InfoFrame.infotext:SetText(L["info text"])
        self.InfoFrame.infotext:SetPoint("TOP",self.InfoFrame,"TOP",10,-30)
        self.InfoFrame.infotext:SetJustifyH("LEFT")

        self.InfoFrame.closebtn=CreateFrame("Button","BT_infoclose",self.InfoFrame)
        self.InfoFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.InfoFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.InfoFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.InfoFrame.closebtn:SetWidth(20)
        self.InfoFrame.closebtn:SetHeight(20)
        self.InfoFrame.closebtn:SetPoint("TOPRIGHT",self.InfoFrame,"TOPRIGHT",-5,-5)
        self.InfoFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.InfoFrame.closebtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
    end
    self.InfoFrame:Show()
    self.InfoFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
    if(self.currInstanceId ~= "EMPTY" and self.modules[self.currModuleId].info)then
        self.InfoFrame.infotext:SetText(L["info text"]..self.modules[self.currModuleId].info)
    else
        self.InfoFrame.infotext:SetText(L["info text"])
    end

end;

---------------------------------------------------------
--- opens Info message
---------------------------------------------------------

function BossTactics:ShowInfoMessage(message)
    if (not message)then return end

    if(self.InfoMessageFrame == nil)then
        self.InfoMessageFrame = CreateFrame("Frame","BT_messageframe",UIParent)
        self.InfoMessageFrame:ClearAllPoints()
        self.InfoMessageFrame:SetPoint("CENTER",UIParent)
        self.InfoMessageFrame:SetHeight(150)
        self.InfoMessageFrame:SetWidth(350)
        self.InfoMessageFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.InfoMessageFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.InfoMessageFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.InfoMessageFrame.OkBtn = CreateFrame("Button","BT_infomessage_ok",self.InfoMessageFrame,"UIPanelButtonTemplate")
        self.InfoMessageFrame.OkBtn:SetWidth(100)
        self.InfoMessageFrame.OkBtn:SetHeight(20)
        self.InfoMessageFrame.OkBtn:SetText(L["Ok"])
        self.InfoMessageFrame.OkBtn:SetPoint("BOTTOM",self.InfoMessageFrame,"BOTTOM",0,15)
        self.InfoMessageFrame.OkBtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.InfoMessageFrame.OkBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        self.InfoMessageFrame.infotext = self.InfoMessageFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.InfoMessageFrame.infotext:SetTextColor(1,1,1)
        self.InfoMessageFrame.infotext:SetWidth(280)
        self.InfoMessageFrame.infotext:SetPoint("TOP",self.InfoMessageFrame,"TOP",0,-40)
        self.InfoMessageFrame.infotext:SetJustifyH("LEFT")

        self.InfoMessageFrame.closebtn=CreateFrame("Button","BT_infomessage_close",self.InfoMessageFrame)
        self.InfoMessageFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.InfoMessageFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.InfoMessageFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.InfoMessageFrame.closebtn:SetWidth(20)
        self.InfoMessageFrame.closebtn:SetHeight(20)
        self.InfoMessageFrame.closebtn:SetPoint("TOPRIGHT",self.InfoMessageFrame,"TOPRIGHT",-5,-5)
        self.InfoMessageFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.InfoMessageFrame.closebtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
    end
    self.InfoMessageFrame:Show()
    self.InfoMessageFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
    self.InfoMessageFrame.infotext:SetText(message)
end;

---------------------------------------------------------
--- opens Info that version incompatible
---------------------------------------------------------

function BossTactics:ShowVersionInfoFrame()
    if(self.VersionFrame == nil)then
        self.VersionFrame = CreateFrame("Frame","BT_Versionframe",UIParent)
        self.VersionFrame:ClearAllPoints()
        self.VersionFrame:SetPoint("CENTER",UIParent)
        self.VersionFrame:SetHeight(130)
        self.VersionFrame:SetWidth(320)
        self.VersionFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.VersionFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.VersionFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.VersionFrame.OkBtn = CreateFrame("Button","BT_version_ok",self.VersionFrame,"UIPanelButtonTemplate")
        self.VersionFrame.OkBtn:SetWidth(100)
        self.VersionFrame.OkBtn:SetHeight(20)
        self.VersionFrame.OkBtn:SetText(L["Ok"])
        self.VersionFrame.OkBtn:SetPoint("BOTTOM",self.VersionFrame,"BOTTOM",0,15)
        self.VersionFrame.OkBtn:SetScript("OnClick",function() this:GetParent():Hide() end)

        self.VersionFrame.Versiontext = self.VersionFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.VersionFrame.Versiontext:SetTextColor(1,1,1)
        self.VersionFrame.Versiontext:SetWidth(270)
        self.VersionFrame.Versiontext:SetHeight(80)
        self.VersionFrame.Versiontext:SetText(L["Version info text"])
        self.VersionFrame.Versiontext:SetPoint("TOP",self.VersionFrame,"TOP",10,-10)
        self.VersionFrame.Versiontext:SetJustifyH("LEFT")

        self.VersionFrame.closebtn=CreateFrame("Button","BT_Versionclose",self.VersionFrame)
        self.VersionFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.VersionFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.VersionFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.VersionFrame.closebtn:SetWidth(20)
        self.VersionFrame.closebtn:SetHeight(20)
        self.VersionFrame.closebtn:SetPoint("TOPRIGHT",self.VersionFrame,"TOPRIGHT",-5,-5)
        self.VersionFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)

    end
    self.VersionFrame:Show()
    if(self.MainWindow) then
        self.VersionFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
        self.VersionFrame.OkBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
        self.VersionFrame.closebtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
    end

end;

-----------------------------------------------------------------
--frame for configuration of the chat features
-----------------------------------------------------------------

function BossTactics:ShowChatConfigFrame()

	 if(self.ChatConfigFrame == nil)then
        self.ChatConfigFrame = CreateFrame("Frame","BT_ChatConfigFrame",UIParent)
        self.ChatConfigFrame:ClearAllPoints()
        self.ChatConfigFrame:SetPoint("CENTER",UIParent)
        self.ChatConfigFrame:SetHeight(180)
        self.ChatConfigFrame:SetWidth(430)
        self.ChatConfigFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.ChatConfigFrame:SetBackdropColor(1/255, 1/255, 1/255)

        self.ChatConfigFrame.OkBtn = CreateFrame("Button","BT_chaframe_ok",self.ChatConfigFrame,"UIPanelButtonTemplate")
        self.ChatConfigFrame.OkBtn:SetWidth(100)
        self.ChatConfigFrame.OkBtn:SetHeight(20)
        self.ChatConfigFrame.OkBtn:SetText(L["Ok"])
        self.ChatConfigFrame.OkBtn:SetPoint("BOTTOMRIGHT",self.ChatConfigFrame,"BOTTOMRIGHT",-15,15)
        self.ChatConfigFrame.OkBtn:SetScript("OnClick",function() this:GetParent():Hide() end)

        self.ChatConfigFrame.title = self.ChatConfigFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.ChatConfigFrame.title:SetTextColor(1,1,1)
        self.ChatConfigFrame.title:SetText(L["title ChatConfig"])
        self.ChatConfigFrame.title:SetPoint("TOP",self.ChatConfigFrame,"TOP",0,-15)

        self.ChatConfigFrame.ChannelBtn = CreateFrame("Button","BT_modeBtn",self.ChatConfigFrame,"UIPanelButtonTemplate")
        self.ChatConfigFrame.ChannelBtn:SetWidth(130)
        self.ChatConfigFrame.ChannelBtn:SetHeight(20)
        self.ChatConfigFrame.ChannelBtn:SetText(L["select channel"])
        self.ChatConfigFrame.ChannelBtn:SetPoint("TOPLEFT",self.ChatConfigFrame,"TOPLEFT",20,-50)
        self.ChatConfigFrame.ChannelBtn:SetScript("OnClick",function()
                        local tbl = {}
                        for i,v in ipairs (self.db.char.joinedChannelList)do
                        	local channinfo = self:GetChannelInfoFromId(v)
                        	tinsert(tbl, {channinfo.name,channinfo.name})
                        end
                        self.currDropdownTable = {
                                ["func"] = function (arg1) self:CannelConfDropdownClick(arg1) end,
                                ["values"] = tbl
                            }
                        ToggleDropDownMenu(1, nil, self.ChatConfigFrame.ChannelDropdown,this, 0, 0);
                          end)
        self.ChatConfigFrame.ChannelDropdown = CreateFrame("Frame", "BT_ChannelConfDropdown", self.ChatConfigFrame.ChannelBtn, "UIDropDownMenuTemplate");
        UIDropDownMenu_Initialize(self.ChatConfigFrame.ChannelDropdown, function () BossTactics:DropDownOneLevel_Initialize() end, "MENU");

        self.ChatConfigFrame.ColorLabel = self.ChatConfigFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.ChatConfigFrame.ColorLabel:SetTextColor(1,1,1)
        self.ChatConfigFrame.ColorLabel:SetText(L["Color"]..":")
        self.ChatConfigFrame.ColorLabel:SetPoint("TOPLEFT",self.ChatConfigFrame,"TOPLEFT",20,-85)

        self.ChatConfigFrame.ColorInput = CreateFrame("EditBox","BT_colorinputbox",self.ChatConfigFrame, "InputBoxTemplate")
		self.ChatConfigFrame.ColorInput:SetMaxLetters(6)
		self.ChatConfigFrame.ColorInput:SetPoint("TOPLEFT",self.ChatConfigFrame, "TOPLEFT", 70,-80)
		self.ChatConfigFrame.ColorInput:SetWidth(70);
		self.ChatConfigFrame.ColorInput:SetHeight(20);
		self.ChatConfigFrame.ColorInput:SetText("");
		self.ChatConfigFrame.ColorInput:SetAutoFocus(false);
		self.ChatConfigFrame.ColorInput:SetScript("OnEscapePressed", function()
					this:ClearFocus()
					end)

		self.ChatConfigFrame.ColorSelectBtn = CreateFrame("Button","BT_modeBtn",self.ChatConfigFrame,"UIPanelButtonTemplate")
        self.ChatConfigFrame.ColorSelectBtn:SetWidth(80)
        self.ChatConfigFrame.ColorSelectBtn:SetHeight(20)
        self.ChatConfigFrame.ColorSelectBtn:SetText(L["Color"])
        self.ChatConfigFrame.ColorSelectBtn:SetPoint("TOPLEFT",self.ChatConfigFrame,"TOPLEFT",145,-80)
        self.ChatConfigFrame.ColorSelectBtn:Disable()
        self.ChatConfigFrame.ColorSelectBtn:SetScript("OnClick",function()
                       local function Color_Change()
	                        local r, g, b = ColorPickerFrame:GetColorRGB()
                            BossTactics:UpdateColor(r,g,b)
                        end
                        local function Color_Abort(prevvals)
	                        local R,G,B = unpack(prevvals)
	                        BossTactics:UpdateColor(R,G,B)
                        end
                        ColorPickerFrame.func = Color_Change
                        ColorPickerFrame.cancelFunc = Color_Abort
                        local chaninfo = self:GetChannelInfoFromShortcut(this:GetParent().ChannelBtn:GetText())
                        local r,g,b = self:HexToRgb(chaninfo.color)
                        ColorPickerFrame.previousValues = {r, g, b}
                        ColorPickerFrame:SetColorRGB(r, g, b)
	    			    ColorPickerFrame:Show()
                          end)
        self.ChatConfigFrame.StdBtn = CreateFrame("Button","BT_modeBtn",self.ChatConfigFrame,"UIPanelButtonTemplate")
        self.ChatConfigFrame.StdBtn:SetWidth(180)
        self.ChatConfigFrame.StdBtn:SetHeight(20)
        self.ChatConfigFrame.StdBtn:SetText(L["Recover Standard"])
        self.ChatConfigFrame.StdBtn:SetPoint("TOPLEFT",self.ChatConfigFrame,"TOPLEFT",235,-80)
        self.ChatConfigFrame.StdBtn:Disable()
        self.ChatConfigFrame.StdBtn:SetScript("OnClick",function()
        		local selChan = self.ChatConfigFrame.ChannelBtn:GetText()
        		local def = self:GetDefaults()
        		local chaninfo = self:GetChannelInfoFromShortcut(selChan)
                if(selChan == BabbleClass["Druid"])then
		            self.db.profile.cdruid=def.profile.cdruid
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cdruid)
		            chaninfo.color = def.profile.cdruid
	            elseif(selChan == BabbleClass["Deathknight"])then
                    self.db.profile.cdeathknight=def.profile.deathknight
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cdeathknight)
		            chaninfo.color = def.profile.cdeathknight
                elseif(selChan == BabbleClass["Hunter"])then
                    self.db.profile.chunter=def.profile.chunter
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.chunter)
		            chaninfo.color = def.profile.chunter
                elseif(selChan == BabbleClass["Mage"])then
                    self.db.profile.cmage=def.profile.cmage
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cmage)
		            chaninfo.color = def.profile.cmage
                elseif(selChan == BabbleClass["Paladin"])then
                    self.db.profile.cpaladin=def.profile.cpaladin
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cpaladin)
		            chaninfo.color = def.profile.cpaladin
                elseif(selChan == BabbleClass["Priest"])then
                    self.db.profile.cpriest=def.profile.cpriest
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cpriest)
		            chaninfo.color = def.profile.cpriest
                elseif(selChan == BabbleClass["Rogue"])then
                    self.db.profile.crogue=def.profile.crogue
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.crogue)
		            chaninfo.color = def.profile.crogue
                elseif(selChan == BabbleClass["Shaman"])then
                    self.db.profile.cshaman=def.profile.cshaman
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cshaman)
		            chaninfo.color = def.profile.cshaman
                elseif(selChan == BabbleClass["Warlock"])then
                    self.db.profile.cwarlock=def.profile.cwarlock
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cwarlock)
		            chaninfo.color = def.profile.cwarlock
                elseif(selChan == BabbleClass["Warrior"])then
                   self.db.profile.cwarrior=def.profile.cwarrior
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cwarrior)
		            chaninfo.color = def.profile.cwarrior
                elseif(selChan == L["tank"])then
                    self.db.profile.ctank=def.profile.ctank
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.ctank)
		            chaninfo.color = def.profile.ctank
                elseif(selChan == L["healer"])then
                    self.db.profile.chealer=def.profile.chealer
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.chealer)
		            chaninfo.color = def.profile.chealer
                elseif(selChan == L["ranged DPS"])then
                    self.db.profile.cdd=def.profile.cdd
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cdd)
		            chaninfo.color = def.profile.cdd
                elseif(selChan == L["melee"])then
                    self.db.profile.cmelee=def.profile.cmelee
		            self.ChatConfigFrame.ColorInput:SetText(def.profile.cmelee)
		            chaninfo.color = def.profile.cmelee
                end
                          end)


        self.ChatConfigFrame.closebtn=CreateFrame("Button","BT_chatframeclose",self.ChatConfigFrame)
        self.ChatConfigFrame.closebtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.ChatConfigFrame.closebtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.ChatConfigFrame.closebtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.ChatConfigFrame.closebtn:SetWidth(20)
        self.ChatConfigFrame.closebtn:SetHeight(20)
        self.ChatConfigFrame.closebtn:SetPoint("TOPRIGHT",self.ChatConfigFrame,"TOPRIGHT",-5,-5)
        self.ChatConfigFrame.closebtn:SetScript("OnClick",function() this:GetParent():Hide() end)

    end
    self.ChatConfigFrame:Show()
    if(self.MainWindow) then
        self.ChatConfigFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+20)
        self.ChatConfigFrame.OkBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
        self.ChatConfigFrame.closebtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
    end

end;

function BossTactics:CannelConfDropdownClick(chan)

	local chaninfo = self:GetChannelInfoFromShortcut(chan)
	self.ChatConfigFrame.ChannelBtn:SetText(chan)
	self.ChatConfigFrame.ColorInput:SetText(chaninfo.color)
	self.ChatConfigFrame.StdBtn:Enable()
	self.ChatConfigFrame.ColorSelectBtn:Enable()

end

------------------------------------------------------------------
--Panel where the actual real raidleader
--can choose options to set his leaders
------------------------------------------------------------------

function BossTactics:ShowRaidleadersFrame()

    if(self.RaidleadersFrame == nil)then
        self.RaidleadersFrame = CreateFrame("Frame","BT_RaidleadersFrame",self.MainWindow)
        self.RaidleadersFrame:ClearAllPoints()
        self.RaidleadersFrame:SetPoint("CENTER",UIParent)
        self.RaidleadersFrame:SetHeight(250)
        self.RaidleadersFrame:SetWidth(450)
        self.RaidleadersFrame:SetBackdrop({
            bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = false,
            edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border", edgeSize = 32,
            insets = {left = 5, right = 5, top = 0, bottom = 5},
        })
        self.RaidleadersFrame:SetBackdropColor(1/255, 1/255, 1/255)
        --self.RaidleadersFrame:SetBackdropBorderColor(1.0,0,0.0)

        self.RaidleadersFrame.SaveBtn = CreateFrame("Button","BT_Raidleadersframe_Save",self.RaidleadersFrame,"UIPanelButtonTemplate")
        self.RaidleadersFrame.SaveBtn:SetWidth(100)
        self.RaidleadersFrame.SaveBtn:SetHeight(20)
        self.RaidleadersFrame.SaveBtn:SetText(L["Save"])
        self.RaidleadersFrame.SaveBtn:SetPoint("BOTTOMLEFT",self.RaidleadersFrame,"BOTTOMLEFT",15,15)
        self.RaidleadersFrame.SaveBtn:SetScript("OnClick",function()
                    if(self.RaidleadersFrame.SaveCheckBoxBtn:GetChecked())then
                        self.db.profile.saveRaidleaders = true
                    else
                        self.db.profile.saveRaidleaders = false
                    end
                    --self.db.profile.raidleaderList = {}
                    for i,v in ipairs(self.RaidleadersFrame.SelectedFrame.TextArray)do
                        local found = false
                        for index,value in ipairs(self.db.profile.raidleaderList)do
                            if(value == v:GetText())then
                               found = true
                               break
                            end
                        end
                        if(not found)then
                               tinsert(self.db.profile.raidleaderList,v:GetText())
                               self:BT_SendDataMessage("{AYES}",true,v:GetText())
                        end
                    end
                    for i,v in ipairs(self.db.profile.raidleaderList)do
                        local found = false
                        for index,value in ipairs(self.RaidleadersFrame.SelectedFrame.TextArray)do
                            if(v == value:GetText())then
                               found = true
                               break
                            end
                        end
                        if(not found)then
                           tremove(self.db.profile.raidleaderList,i)
                           if(UnitInRaid(v))then
                               self:BT_SendDataMessage("{ANO}",true,v)
                           end
                        end
                    end
                    this:GetParent():Hide()
             end)
        self.RaidleadersFrame.SaveBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        self.RaidleadersFrame.CancelBtn = CreateFrame("Button","BT_Raidleadersframe_Cancel",self.RaidleadersFrame,"UIPanelButtonTemplate")
        self.RaidleadersFrame.CancelBtn:SetWidth(100)
        self.RaidleadersFrame.CancelBtn:SetHeight(20)
        self.RaidleadersFrame.CancelBtn:SetText(L["Cancel"])
        self.RaidleadersFrame.CancelBtn:SetPoint("BOTTOMLEFT",self.RaidleadersFrame,"BOTTOMLEFT",120,15)
        self.RaidleadersFrame.CancelBtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.RaidleadersFrame.CancelBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        self.RaidleadersFrame.Title = self.RaidleadersFrame:CreateFontString(nil,"OVERLAY","MailTextFontNormal")
        self.RaidleadersFrame.Title:SetTextColor(1,1,1)
        self.RaidleadersFrame.Title:SetText(L["raidleaders title"])
        self.RaidleadersFrame.Title:SetPoint("TOP",self.RaidleadersFrame,"TOP",0,-20)
        self.RaidleadersFrame.Title:SetJustifyH("LEFT")

        self.RaidleadersFrame.Raidleadersbtn=CreateFrame("Button","BT_cRaidleaders",self.RaidleadersFrame)
        self.RaidleadersFrame.Raidleadersbtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
        self.RaidleadersFrame.Raidleadersbtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
        self.RaidleadersFrame.Raidleadersbtn:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
        self.RaidleadersFrame.Raidleadersbtn:SetWidth(20)
        self.RaidleadersFrame.Raidleadersbtn:SetHeight(20)
        self.RaidleadersFrame.Raidleadersbtn:SetPoint("TOPRIGHT",self.RaidleadersFrame,"TOPRIGHT",-5,-5)
        self.RaidleadersFrame.Raidleadersbtn:SetScript("OnClick",function() this:GetParent():Hide() end)
        self.RaidleadersFrame.Raidleadersbtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        local choosableFrame = CreateFrame("Frame","BT_choosableRaidleaderframe",self.RaidleadersFrame)
        self.RaidleadersFrame.ChoosableFrame = choosableFrame

        choosableFrame:ClearAllPoints();
        choosableFrame:SetPoint("TOPLEFT",self.RaidleadersFrame, "TOPLEFT", 10,-70)
        choosableFrame:SetWidth(150);
        choosableFrame:SetHeight(70);
        choosableFrame:SetBackdrop({
        --bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 12,
        --edgeFile = "Interface\\TutorialFrame\\TutorialFrameBorder",
        edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
        --insets = {left = 1, right = 1, top = 1, bottom = 1},
        })
        choosableFrame:SetBackdropBorderColor(16/255,24/255,177/255)
        choosableFrame:SetBackdropColor(24/255, 24/255, 24/255)
        self.RaidleadersFrame.titleChoosableScroll = self.RaidleadersFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
        self.RaidleadersFrame.titleChoosableScroll:SetTextColor(1,1,1)
        self.RaidleadersFrame.titleChoosableScroll:SetText(L["Title Choosable"])
        self.RaidleadersFrame.titleChoosableScroll:SetPoint("TOPLEFT",self.RaidleadersFrame,"TOPLEFT",10,-50)
        choosableFrame.offset = 1
        choosableFrame.scrollUp = false
        choosableFrame.TextArray = {}
        choosableFrame.CheckSelected = function()
                 if(#choosableFrame.TextArray >= 1)then
                    choosableFrame.SelectedTexture:Show()
                else
                    choosableFrame.SelectedTexture:Hide()
                end
            end

        choosableFrame.SelectedTexture = choosableFrame:CreateTexture("BT_SelectedChoosable","BACKGROUND")
        choosableFrame.SelectedTexture:SetPoint("TOPLEFT",choosableFrame,"TOPLEFT",5,-10)
        choosableFrame.SelectedTexture:SetWidth(choosableFrame:GetWidth()-30)
        choosableFrame.SelectedTexture:SetHeight(15)
        choosableFrame.SelectedTexture:SetTexture(16/255,24/255,177/255)

        choosableFrame.scrollDownBtn=CreateFrame("Button","BT_scrolldown_choosableRl",choosableFrame)
        choosableFrame.scrollDownBtn:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up.blp")
        choosableFrame.scrollDownBtn:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down.blp")
        choosableFrame.scrollDownBtn:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight.blp")
        choosableFrame.scrollDownBtn:SetWidth(20)
        choosableFrame.scrollDownBtn:SetHeight(20)
        choosableFrame.scrollDownBtn:SetPoint("BOTTOMRIGHT",choosableFrame,"BOTTOMRIGHT",-5,7)
        choosableFrame.scrollDownBtn:SetScript("OnClick",function()
                if(this:GetParent().offset< #(this:GetParent().TextArray))then
                    local oldoffset = this:GetParent().offset
                    this:GetParent().offset = this:GetParent().offset+1
                    while(this:GetParent().TextArray[this:GetParent().offset] and
                            this:GetParent().TextArray[this:GetParent().offset].status == false) do
                         this:GetParent().offset = this:GetParent().offset+1
                    end
                    if(not this:GetParent().TextArray[this:GetParent().offset]) then
                        this:GetParent().offset = oldoffset
                    end
                    BossTactics:ScrollStringTop(this:GetParent(),this:GetParent().TextArray,false)
                end
                 end)

        choosableFrame.scrollUpBtn=CreateFrame("Button","BT_scrollup_choosableRl",choosableFrame)
        choosableFrame.scrollUpBtn:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up.blp")
        choosableFrame.scrollUpBtn:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down.blp")
        choosableFrame.scrollUpBtn:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight.blp")
        choosableFrame.scrollUpBtn:SetWidth(20)
        choosableFrame.scrollUpBtn:SetHeight(20)
        choosableFrame.scrollUpBtn:SetPoint("TOPRIGHT",choosableFrame,"TOPRIGHT",-5,-7)
        choosableFrame.scrollUpBtn:SetScript("OnClick",function()
                if(this:GetParent().offset > 1)then
                    this:GetParent().scrollUp = true;
                    local oldoffset = this:GetParent().offset
                    this:GetParent().offset = this:GetParent().offset-1
                    while(this:GetParent().TextArray[this:GetParent().offset] and
                            this:GetParent().TextArray[this:GetParent().offset].status == false) do
                         this:GetParent().offset = this:GetParent().offset-1
                    end
                    if(not this:GetParent().TextArray[this:GetParent().offset]) then
                        this:GetParent().offset = oldoffset
                    end
                    BossTactics:ScrollStringTop(this:GetParent(),this:GetParent().TextArray,false)
                end
                 end)

        --make the buttons

        self.RaidleadersFrame.PutLeftBtn = CreateFrame("Button","BT_RL_putleft",self.RaidleadersFrame,"UIPanelButtonTemplate")
        self.RaidleadersFrame.PutLeftBtn:SetWidth(60)
        self.RaidleadersFrame.PutLeftBtn:SetHeight(20)
        self.RaidleadersFrame.PutLeftBtn:SetText("<")
        self.RaidleadersFrame.PutLeftBtn:SetPoint("TOPLEFT",self.RaidleadersFrame,"TOPLEFT",195,-100)
        self.RaidleadersFrame.PutLeftBtn:SetScript("OnClick",function()
                                if(#self.RaidleadersFrame.SelectedFrame.TextArray >= 1)then
                                    local sel = tremove(self.RaidleadersFrame.SelectedFrame.TextArray,self.RaidleadersFrame.SelectedFrame.offset)
                                    if(sel.status) then
                                        local newFontstr = self.RaidleadersFrame.ChoosableFrame:CreateFontString(nil, "OVERLAY","GameFontNormalSmall")
                                        newFontstr:SetText(sel:GetText())
                                        newFontstr:SetTextColor(1,1,1)
                                        newFontstr.status = true
                                        self:InsertionSort(self.RaidleadersFrame.ChoosableFrame.TextArray,newFontstr)
                                        self:ScrollStringTop(self.RaidleadersFrame.ChoosableFrame,self.RaidleadersFrame.ChoosableFrame.TextArray,true)
                                    end
                                    sel:Hide()
                                    if(self.RaidleadersFrame.SelectedFrame.offset > #self.RaidleadersFrame.SelectedFrame.TextArray)then
                                        self.RaidleadersFrame.SelectedFrame.offset = self.RaidleadersFrame.SelectedFrame.offset-1
                                    end
                                    self:ScrollStringTop(self.RaidleadersFrame.SelectedFrame,self.RaidleadersFrame.SelectedFrame.TextArray,false)
                                    self.RaidleadersFrame.ChoosableFrame:CheckSelected()
                                    self.RaidleadersFrame.SelectedFrame:CheckSelected()
                                end
                              end)
        self.RaidleadersFrame.PutLeftBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)


        self.RaidleadersFrame.PutRightBtn = CreateFrame("Button","BT_Rl_putright",choosableFrame,"UIPanelButtonTemplate")
        self.RaidleadersFrame.PutRightBtn:SetWidth(60)
        self.RaidleadersFrame.PutRightBtn:SetHeight(20)
        self.RaidleadersFrame.PutRightBtn:SetText(">")
        self.RaidleadersFrame.PutRightBtn:SetPoint("TOPLEFT",self.RaidleadersFrame,"TOPLEFT",195,-80)
        self.RaidleadersFrame.PutRightBtn:SetScript("OnClick",function()
                                if(#self.RaidleadersFrame.ChoosableFrame.TextArray >= 1 and
                                    self.RaidleadersFrame.ChoosableFrame.TextArray[self.RaidleadersFrame.ChoosableFrame.offset].status)then
                                    local sel = tremove(self.RaidleadersFrame.ChoosableFrame.TextArray,self.RaidleadersFrame.ChoosableFrame.offset)
                                    local newFontstr = self.RaidleadersFrame.SelectedFrame:CreateFontString(nil, "OVERLAY","GameFontNormalSmall")
                                    newFontstr:SetText(sel:GetText())
                                    sel:Hide()
                                    newFontstr:SetTextColor(1,1,1)
                                    newFontstr.status = true
                                    self:InsertionSort(self.RaidleadersFrame.SelectedFrame.TextArray,newFontstr)
                                    self:ScrollStringTop(self.RaidleadersFrame.SelectedFrame,self.RaidleadersFrame.SelectedFrame.TextArray,true)
                                    if(self.RaidleadersFrame.ChoosableFrame.offset > #self.RaidleadersFrame.ChoosableFrame.TextArray)then
                                        self.RaidleadersFrame.ChoosableFrame.offset = self.RaidleadersFrame.ChoosableFrame.offset-1
                                    end
                                    self:ScrollStringTop(self.RaidleadersFrame.ChoosableFrame,self.RaidleadersFrame.ChoosableFrame.TextArray,false)
                                    self.RaidleadersFrame.ChoosableFrame:CheckSelected()
                                    self.RaidleadersFrame.SelectedFrame:CheckSelected()
                                end
                                  end)
        self.RaidleadersFrame.PutRightBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)

        --make the selected box

        local selectedFrame = CreateFrame("Frame","BT_selectedRaidleaderframe",self.RaidleadersFrame)
        self.RaidleadersFrame.SelectedFrame = selectedFrame

        selectedFrame:ClearAllPoints();
        selectedFrame:SetPoint("TOPRIGHT",self.RaidleadersFrame, "TOPRIGHT", -10,-70)
        selectedFrame:SetWidth(150);
        selectedFrame:SetHeight(70);
        selectedFrame:SetBackdrop({
        --bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 12,
        --edgeFile = "Interface\\TutorialFrame\\TutorialFrameBorder",
        edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
        --insets = {left = 1, right = 1, top = 1, bottom = 1},
        })
        selectedFrame:SetBackdropBorderColor(16/255,24/255,177/255)
        selectedFrame:SetBackdropColor(24/255, 24/255, 24/255)
        self.RaidleadersFrame.titleselectedScroll = self.RaidleadersFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
        self.RaidleadersFrame.titleselectedScroll:SetTextColor(1,1,1)
        self.RaidleadersFrame.titleselectedScroll:SetText(L["Title selected"])
        self.RaidleadersFrame.titleselectedScroll:SetPoint("TOPRIGHT",self.RaidleadersFrame,"TOPRIGHT",-80,-50)
        selectedFrame.offset = 1
        selectedFrame.scrollUp = false
        selectedFrame.TextArray = {}
        selectedFrame.CheckSelected = function ()
                if(#selectedFrame.TextArray >= 1)then
                    selectedFrame.SelectedTexture:Show()
                else
                    selectedFrame.SelectedTexture:Hide()
                end
              end

        selectedFrame.SelectedTexture = selectedFrame:CreateTexture("BT_Selectedselected","BACKGROUND")
        selectedFrame.SelectedTexture:SetPoint("TOPLEFT",selectedFrame,"TOPLEFT",5,-10)
        selectedFrame.SelectedTexture:SetWidth(selectedFrame:GetWidth()-30)
        selectedFrame.SelectedTexture:SetHeight(15)
        selectedFrame.SelectedTexture:SetTexture(16/255,24/255,177/255)

        selectedFrame.scrollDownBtn=CreateFrame("Button","BT_scrolldown_selectedRl2",selectedFrame)
        selectedFrame.scrollDownBtn:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Up.blp")
        selectedFrame.scrollDownBtn:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Down.blp")
        selectedFrame.scrollDownBtn:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollDownButton-Highlight.blp")
        selectedFrame.scrollDownBtn:SetWidth(20)
        selectedFrame.scrollDownBtn:SetHeight(20)
        selectedFrame.scrollDownBtn:SetPoint("BOTTOMRIGHT",selectedFrame,"BOTTOMRIGHT",-5,7)
        selectedFrame.scrollDownBtn:SetScript("OnClick",function()
                if(this:GetParent().offset< #(this:GetParent().TextArray))then
                    this:GetParent().offset = this:GetParent().offset+1
                    BossTactics:ScrollStringTop(this:GetParent(),this:GetParent().TextArray,false)
                end
                 end)

        selectedFrame.scrollUpBtn=CreateFrame("Button","BT_scrollup_selectedRl2",selectedFrame)
        selectedFrame.scrollUpBtn:SetNormalTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Up.blp")
        selectedFrame.scrollUpBtn:SetPushedTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Down.blp")
        selectedFrame.scrollUpBtn:SetHighlightTexture("Interface\\Buttons\\UI-ScrollBar-ScrollUpButton-Highlight.blp")
        selectedFrame.scrollUpBtn:SetWidth(20)
        selectedFrame.scrollUpBtn:SetHeight(20)
        selectedFrame.scrollUpBtn:SetPoint("TOPRIGHT",selectedFrame,"TOPRIGHT",-5,-7)
        selectedFrame.scrollUpBtn:SetScript("OnClick",function()
                if(this:GetParent().offset > 1)then
                    this:GetParent().scrollUp = true;
                    this:GetParent().offset = this:GetParent().offset-1
                    BossTactics:ScrollStringTop(this:GetParent(),this:GetParent().TextArray,false)
                end
                 end)

    --make the checkboxes
        self.RaidleadersFrame.SaveCheckBoxBtn = CreateFrame("CheckButton","BT_RL_SaveCheckBox",choosableFrame,"UICheckButtonTemplate")
        self.RaidleadersFrame.SaveCheckBoxBtn:SetWidth(20)
        self.RaidleadersFrame.SaveCheckBoxBtn:SetHeight(20)
        self.RaidleadersFrame.SaveCheckBoxBtn:SetPoint("TOPLEFT",self.RaidleadersFrame,"TOPLEFT",10,-160)
        self.RaidleadersFrame.SaveCheckBoxBtn:SetFrameLevel(self.MainWindow:GetFrameLevel()+22)
        self.RaidleadersFrame.SaveCheckBoxBtn:SetChecked(self.db.profile.saveRaidleaders)

        self.RaidleadersFrame.TextSaveCB = self.RaidleadersFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
        self.RaidleadersFrame.TextSaveCB:SetTextColor(1,1,1)
        self.RaidleadersFrame.TextSaveCB:SetText(L["Text Save Checkbox"])
        self.RaidleadersFrame.TextSaveCB:SetWidth(400)
        self.RaidleadersFrame.TextSaveCB:SetJustifyH("LEFT")
        self.RaidleadersFrame.TextSaveCB:SetPoint("TOPLEFT",self.RaidleadersFrame,"TOPLEFT",35,-160)

    end
    self:UpdateRaidleaderFrame()
    self.RaidleadersFrame:Show()
    self.RaidleadersFrame:SetFrameLevel(self.MainWindow:GetFrameLevel()+21)

end;

function BossTactics:UpdateRaidleaderFrame()

    if(not self.RaidleadersFrame) then return end

    local choosableFrame = self.RaidleadersFrame.ChoosableFrame
    local selectedFrame = self.RaidleadersFrame.SelectedFrame
    local anzMembers = GetNumRaidMembers()
    local i =0

    for i,v in ipairs(selectedFrame.TextArray)do
        v:Hide()
    end
    selectedFrame.TextArray = {}

   -- if(self.db.profile.saveRaidleaders)then
        for i,v in ipairs(self.db.profile.raidleaderList)do
           local tmpFontstr = selectedFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
           tmpFontstr:SetTextColor(1,1,1)
           tmpFontstr:SetText(v)
           tmpFontstr.status = true
           self:InsertionSort(selectedFrame.TextArray,tmpFontstr)
           self:ScrollStringTop(selectedFrame,selectedFrame.TextArray,true)
        end
   -- end
    for i,v in ipairs(choosableFrame.TextArray)do
        v:Hide()
    end
    choosableFrame.TextArray = {}
    self:UpdateRaidleaderFrameData()

end;

function BossTactics:UpdateRaidleaderFrameData()
    local choosableFrame = self.RaidleadersFrame.ChoosableFrame
    local selectedFrame = self.RaidleadersFrame.SelectedFrame
    local anzMembers = GetNumRaidMembers()
    for index,v in ipairs(selectedFrame.TextArray) do
         v:SetTextColor(152/255,152/255,152/255)
         v.status = false
    end
    for index,v in ipairs(choosableFrame.TextArray) do
         v:SetTextColor(152/255,152/255,152/255)
         v.status = false
         v.found = false
    end
     for i=1, anzMembers, 1 do
        local name, rank, subgroup, level, class,
              fileName,zone, online, isDead, role, isML = GetRaidRosterInfo(i)
        if(rank == 1 and name ~= self.player)then
            local found = false
            for index,v in ipairs(selectedFrame.TextArray) do
                if(v:GetText() == name) then
                    found = true
                    v:SetTextColor(1,1,1)
                    v.status = true
                    break
                end
            end
            if(not found)then
               for index,v in ipairs(choosableFrame.TextArray) do
                    if(v:GetText() == name) then
                        found = true
                        v:SetTextColor(1,1,1)
                        v.status = true;
                        v.found = true
                        break
                    end
                end
               if(not found)then
                   local tmpFontstr = choosableFrame:CreateFontString(nil,"OVERLAY","GameFontNormalSmall")
                   tmpFontstr:SetTextColor(1,1,1)
                   tmpFontstr:SetText(name)
                   self:InsertionSort(choosableFrame.TextArray,tmpFontstr)
                   self:ScrollStringTop(choosableFrame,choosableFrame.TextArray,true)
                   tmpFontstr.status = true
               end
            end
        end
    end
    selectedFrame:CheckSelected()
    choosableFrame:CheckSelected()

end;